<?php

// Message Pack for Discuz! Version 1.0.0
// Created by Crossday

$language = array
(
	'undefined_action' => '未定義操作，請返回。',
	'group_nopermission' => '您所在的用戶組($grouptitle)無法進行此操作。',
	'group_expiry_disabled' => '您目前沒有即將到期的用戶組，請返回。',
	'period_nopermission' => '對不起，管理員設置了每日 $banperiods 不能進行此操作或訪問此頁面，請其他時間再試。',
	'submit_seccode_invalid' => '您輸入的驗證碼不正確，無法提交，請返回修改。',
	'submit_invalid' => '您的請求來路不正確或驗證字串不符，無法提交。如果您安裝了某種默認屏蔽來路信息的個人防火牆軟件(如 Norton Internet Security)，請設置其不要禁止來路信息後再試。',
	'not_loggedin' => '對不起，您還沒有登錄，無法進行此操作。',
	'board_closed' => '對不起，本論壇暫時關閉，詳情請<a href=\"mailto:$adminemail\">聯繫管理員</a>。',
	'max_pages' => '管理員設置了本內容可以被翻閱到的最大頁數為 $pages 頁，如需查看相關內容，請返回並指定查詢條件後再試。',

	'login_invalid' => '用戶名無效，密碼錯誤或安全問題回答錯誤，您可以有至多 5 次嘗試，請返回。',
	'login_strike' => '累計 5 次錯誤嘗試，15 分鐘內您將不能登錄論壇。',
	'login_succeed' => '歡迎您回來，{$discuz_userss}。現在將轉入登錄前頁面。',
	'login_succeed_inactive_member' => '歡迎您回來，{$discuz_userss}。您的帳號處於非激活狀態，現在將轉入控制面板。',
	'logout_succeed' => '您已退出論壇，現在將以遊客身份轉入退出前頁面。',

	'user_banned' => '對不起，您的 IP 地址不在被允許的範圍內，或您的賬號被禁用，無法訪問本論壇。',
	'word_banned' => '對不起，您填寫的內容(如簽名、帖子、短消息等)包含不良內容而無法提交，請返回修改。',

	'forum_nonexistence' => '指定的論壇不存在，請返回。',
	'forum_passwd_correct' => '密碼驗證成功，現在將轉入主題列表。',
	'forum_passwd_incorrect' => '您輸入的密碼不正確，不能訪問這個論壇。',
	'forum_nopermission' => '本論壇只有特定用戶組可以訪問。',

	'thread_nonexistence' => '指定的主題不存在或已被刪除或正在被審核，請返回。',
	'thread_nopermission' => '對不起，本帖要求閱讀權限高於 $thread[readperm] 才可瀏覽，請返回。',
	'thread_poll_closed' => '本主題已關閉，無法繼續投票，請返回。',
	'thread_poll_voted' => '您已參與過這個投票，請返回。',
	'thread_poll_invalid' => '您沒有選擇投票選項，請返回修改。',
	'thread_poll_succeed' => '您的投票成功提交，現在將轉入主題頁。',
	'thread_rate_moderator_invalid' => '對不起，作為版主您只能在自己的管轄範圍內評分，請返回。',
	'thread_rate_range_invalid' => '您未輸入分值或超過每次評分範圍限制，請返回修改。',
	'thread_rate_timelimit' => '對不起，您不能對發表於 $karmaratelimit 小時前的帖子進行評分，請返回。',
	'thread_rate_member_invalid' => '對不起，您不能給自己發表的帖子評分，請返回。',
	'thread_rate_ctrl' => '對不起，您最近 24 小時評分數超過限制，請返回修改。',
	'thread_rate_duplicate' => '對不起，您不能對同一個帖子重複評分，請返回。',
	'thread_rate_succeed' => '感謝您的參與，現在將轉入評分前頁面。',
	'thread_rate_anonymous' => '對不起，您不能對匿名帖評分，請返回。',
	'thread_rate_log_nonexistence' => '對不起，指定帖子在近一年內沒有評分記錄，請返回。',
	'thread_pay_succeed' => '您已成功購買本主題，現在將轉入主題頁面。',
	'thread_report_disabled' => '對不起，管理員關閉了報告帖子功能，請返回。',
	'thread_report_flood_ctrl' => '對不起，您兩次報告間隔少於 $floodctrl 秒，請返回。',
	'thread_maxpostsperhour_invalid' => '對不起，本站規定會員每小時最多只能發表 $maxpostsperhour 個帖子。',
	'thread_report_invalid' => '您沒有選擇對誰報告本帖，請返回修改。',
	'thread_report_succeed' => '您的意見已經報告給版主和管理員，現在將轉入主題頁面。',

	'digest_nonexistence' => '對不起，指定範圍內沒有精華帖，請返回。',

	'view_log_invalid' => '瀏覽量記錄文件($logfile)無法寫入，請設置其屬性 777 或刪除後重新建立。',

	'attachment_referer_invalid' => '對不起，請不要從外部鏈接下載本論壇的附件。',
	'attachment_nopermission' => '對不起，本附件要求閱讀權限高於 $attach[readperm] 才可下載，請返回。',
	'attachment_forum_nopermission' => '對不起，只有特定用戶可以下載本論壇的附件，請返回。',
	'attachment_nonexistence' => '附件文件不存在或無法讀入，請與管理員聯繫。',
	'attachment_payto' => '附件所在主題需要付費，請您付費後下載。',

	'post_hide_nopermission' => '對不起，您沒有權限使用 [hide] 代碼，請返回修改。',
	'post_newbie_span' => '對不起，您只在註冊時間起 $newbiespan 小時後才有發帖權限，請返回。',
	'post_forum_newthread_nopermission' => '對不起，本論壇只有特定用戶組可以發新話題，請返回。',
	'post_forum_newreply_nopermission' => '對不起，本論壇只有特定用戶組可以回復，請返回。',
	'post_thread_closed' => '對不起，本主題已關閉，不再接受新回復，請返回。',
	'post_thread_closed_by_dateline' => '對不起，管理員設置了本論壇發表於 $forum[autoclose] 天以前的主題自動關閉，不再接受新回復，請返回。',
	'post_thread_closed_by_lastpost' => '對不起，管理員設置了本論壇最後回復於 $forum[autoclose] 天以前的主題自動關閉，不再接受新回復，請返回。',
	'post_subject_toolong' => '對不起，您的標題超過 80 個字符，請返回修改標題長度。',
	'post_message_tooshort' => '對不起，您的帖子小於 $minpostsize 個字符的限制，請返回修改。',
	'post_message_toolong' => '對不起，您的帖子超過 $maxpostsize 個字符的限制，請返回修改。',
	'post_sm_isnull' => '您沒有輸入標題或內容，請返回填寫。',
	'post_type_isnull' => '您沒有選擇主題的類別，請返回修改。',
	'post_flood_ctrl' => '對不起，您兩次發表間隔少於 $floodctrl 秒，請不要灌水！',
	'post_net_price_iszero' => '您的主題售價扣除積分交易稅後為 0，請返回修改。',
	'post_poll_option_toomany' => '對不起，您的投票選項超過 $maxpolloptions 個，請返回修改。',
	'post_edit_reward_nopermission' => '對不起，懸賞已經結束，無法退還積分，請返回。',
	'post_edit_reward_already_reply' => '對不起，您不能刪除已經有回復的懸賞，請返回。',
	'post_edit_nopermission' => '對不起，您沒有權力編輯他人發表的帖子或刪除已被他人回復的帖子，請返回。',
	'post_edit_timelimit' => '對不起，您的帖子從發表到現在已超過 $edittimelimit 分鐘，不能再進行編輯，請返回。',
	'post_edit_moderate' => '對不起，管理員設置了需要對發帖進行審核，您沒有權力編輯已通過審核的帖子，請返回。',
	'post_edit_delete_succeed' => '主題刪除成功，現在將轉入主題列表。',
	'post_attachment_toobig' => '對不起，您的附件大小超過論壇限制，請返回修改。',
	'post_attachment_type_toobig' => '對不起，您的附件超過 \".$extension\" 類型 $typemaxsize 的限制，請返回修改。',
	'post_attachment_ext_notallowed' => '對不起，不支持上傳此類擴展名的附件，請返回修改。',
	'post_attachment_size_invalid' => '對不起，您上傳的附件尺寸為 0，系統不允許上傳此類附件，請返回修改。',
	'post_attachment_quota_exceed' => '對不起，您最近 24 小時上傳的附件已超過 $maxsizeperday 字節的限制，無法繼續上傳，請返回或稍後再試。',
	'post_attachment_save_error' => '附件文件無法保存到服務器，可能是目錄屬性設置問題，請與管理員聯繫。',
	'post_edit_succeed' => '您的帖子編輯成功，現在將轉入主題頁。<br><br><a href=\"forumdisplay.php?fid=$fid\">[ 需要轉入主題列表請點擊這裡 ]</a>',
	'post_reply_succeed' => '非常感謝，您的回復已經發佈，現在將轉入主題頁。<br><br><a href=\"forumdisplay.php?fid=$fid\">[ 需要轉入主題列表請點擊這裡 ]</a>',

	'post_reply_blog_succeed' => '非常感謝，您的評論已經發佈，現在將轉入文集。',
	'post_reply_mod_succeed' => '非常感謝，管理員設置了需要對新回復進行審核，您的帖子通過審核後將被顯示出來，現在將轉入主題列表。',
	'post_reply_mod_blog_succeed' => '非常感謝，管理員設置了需要對評論進行審核，您的評論通過審核後將被顯示出來，現在將轉入文集。',
	'post_newthread_succeed' => '非常感謝，您的主題已經發佈，現在將轉入主題頁。<br><br><a href=\"forumdisplay.php?fid=$fid\">[ 需要轉入主題列表請點擊這裡 ]</a>',
	'post_newthread_blog_succeed' => '非常感謝，您的文章已經發佈，現在將轉入文集。',
	'post_newthread_blog_invalid' => '對不起，您沒有權限或管理員設置了禁止在本版發表文章，請返回。',
	'post_newthread_mod_succeed' => '非常感謝，管理員設置了需要對新主題進行審核，現在將轉入主題列表，您的帖子通過審核後將被顯示出來。',
	'post_newthread_mod_blog_succeed' => '非常感謝，管理員設置了需要對本欄目新文章進行審核，您的文章通過審核後將被顯示出來，現在將轉入文集。',

	'register_disable' => '對不起，目前論壇禁止新用戶註冊，請返回。',
	'register_ctrl' => '對不起，您的 IP 地址在 $regctrl 小時內只能註冊一個帳號，請返回。',
	'register_flood_ctrl' => '對不起，同一 IP 地址在 24 小時內只能進行 $regfloodctrl 次註冊嘗試，請返回。',
	'register_check_found' => '對不起，您輸入的用戶名 \"$username\" 已經被他人使用，請選擇其他名字後再試。',
	'register_check_notfound' => '恭喜您，您輸入的用戶名 \"$username\" 沒有人使用，可以繼續註冊。',
	'register_manual_verify' => '非常感謝您的註冊，管理員設置了人工驗證新註冊用戶，請等待審核通過，現在將轉入控制面板首頁。',
	'register_succeed' => '非常感謝您的註冊，現在將以會員身份登錄論壇。',

	'profile_username_toolong' => '對不起，您的用戶名超過 15 個字符，請返回輸入一個較短的用戶名。',
	'profile_username_tooshort' => '對不起，您輸入的用戶名小於3個字符, 請返回輸入一個較長的用戶名。',
	'profile_passwd_notmatch' => '兩次輸入的密碼不一致，請返回檢查後重試。',
	'profile_passwd_wrong' => '原密碼不正確，您不能修改密碼或Email或安全提問，請返回。',
	'profile_admin_security_invalid' => '作為管理者之一，您需要填寫安全提問和答案以保障論壇的安全，請返回。',
	'profile_username_duplicate' => '該用戶名已經被註冊了，請返回重新填寫。',
	'profile_email_duplicate' => '該 Email 地址已經被註冊了，請返回重新填寫。',
	'profile_username_illegal' => '用戶名包含敏感字符或被系統屏蔽，請返回重新填寫。',
	'profile_nickname_cstatus_illegal' => '暱稱或自定義頭銜包含敏感字符或被系統屏蔽，請返回重新填寫。',
	'profile_passwd_illegal' => '密碼空或包含非法字符，請返回重新填寫。',
	'profile_email_illegal' => 'Email 地址無效或包含不可使用的郵箱域名，請返回重新填寫。',
	'profile_alipay_illegal' => '支付寶賬號無效，請返回重新填寫。',
	'profile_required_info_invalid' => '您沒有填寫必填項目，請返回修改。',
	'profile_sig_toolong' => '您的簽名長度超過 $maxsigsize 字符的限制，請返回修改。',
	'profile_avatar_invalid' => '您設置的頭像類型無效，請返回修改。',
	'profile_avatar_toobig' => '您設置的頭像超過 $maxavatarsize 字節大小，請返回修改。',
	'profile_avatar_size_invalid' => '讀取遠程頭像尺寸失敗，如確認頭像地址無誤，請返回輸入頭像的寬、高代替原有的「*」。',
	'profile_avatardir_nonexistence' => '頭像目錄 ./images/avatars 不存在，請聯繫管理員。',
	'profile_avatar_succeed' => '您頭像設置已成功更新，現在將轉入個人資料頁。',
	'profile_email_verify' => '確認 Email 已經發送，請用郵件中提供的方法激活您的帳號。如果您沒有收到我們發送的系統郵件，請點擊控制面板首頁中的「重新驗證 Email 有效性」，或嘗試更換另外一個地址。注意：在完成激活之前，根據管理員設置，您將只能以等驗證會員的身份訪問論壇，您可能不能進行發帖等操作。激活成功後，上述限制將自動取消。',
	'profile_succeed' => '您已經成功保存個人資料，現在將轉入控制面板首頁。',
	'profile_avatarshow_bind_succeed' => '天下秀綁定成功，現在將轉入控制面板首頁。',
	'profile_avatarshow_unbind_succeed' => '天下秀解除綁定成功，現在將轉入控制面板首頁。',

	'credits_disabled' => '對不起，管理員沒有啟用論壇積分。',
	'credits_transaction_disabled' => '對不起，交易積分沒有被啟用，無法使用此功能，請返回或與管理員聯繫。',
	'credits_transaction_amount_invalid' => '您要轉賬或兌換的積分數量輸入有誤，請返回修改。',
	'credits_password_invalid' => '您沒有輸入密碼或密碼錯誤，不能進行積分操作，請返回。',
	'credits_policy_lowerlimit' => '對不起，管理員設置了當您的{$extcredits[$id][title]}低於 {$extcredits[$id][lowerlimit]} {$extcredits[$id][unit]}的下限時不能進行此操作，請返回。',
	'credits_balance_insufficient' => '對不起，您的賬戶餘額少於 $minbalance 的最低餘額限制，請返回。',
	'credits_buy_thread' => '對不起，您已經購買過此主題，請勿重複付費。',
	'credits_net_amount_iszero' => '本交易扣除積分交易稅後的淨值為 0，請返回修改。',
	'credits_transfer_send_nonexistence' => '您沒有輸入接收人或接收人不存在，請返回修改。',
	'credits_transfer_self' => '對不起，您不能對自己轉賬，請返回修改。',
	'credits_exchange_invalid' => '您選擇原積分和目標積分相同，不能進行兌換，請返回修改。',
	'credits_transaction_succeed' => '積分操作成功，現在將轉入轉賬與兌換記錄。',
	'credits_addfunds_amount_invalid' => '您單次購買的積分數量超出最大值 $ec_maxcredits 或最小值 $ec_mincredits 的限制。',
	'credits_addfunds_ctrl' => '您兩次提交訂單間隔小於 180 秒，請稍後再試。',
	'credits_addfunds_toomuch' => '您超出本月允許購買 $ec_maxcreditspermonth 的限額。',
	'credits_addfunds_order_invalid' => '當前訂單號無效，請在上一頁重新提交，給您帶來不便敬請諒解。',
	'credits_addfunds_succeed' => '正在提交編號為 $orderid 的訂單。',

	'usergroups_toomany' => '您設置的擴展用戶組超過系統存儲容量，請返回修改。',
	'usergroups_span_invalid' => '對不起，您至少需要支付 $group[minspan] 天的積分價格，請返回。',
	'usergroups_join_succeed' => '成功加入用戶組，現在將轉入公眾用戶組設置。',
	'usergroups_exit_succeed' => '成功退出用戶組，現在將轉入公眾用戶組設置。',
	'usergroups_update_succeed' => '公眾用戶組成功更新，現在將轉入公眾用戶組設置。',
	'usergroups_nonexistence' => '對不起，沒有這個用戶組，請返回。',

	'buddy_add_invalid' => '用戶已存在於您的好友列表中，請返回。',
	'buddy_add_nonexistence' => '指定用戶不存在，請返回修改。',
	'buddy_add_toomany' => '您已經設定了超過 20 位好友，請返回。',
	'buddy_update_succeed' => '好友列表成功更新，現在將返回好友列表。',

	'redirect_nextnewset_nonexistence' => '沒有比當前更新的主題，請返回。',
	'redirect_nextoldset_nonexistence' => '沒有比當前更早的主題，請返回。',

	'favorite_exists' => '您過去已經收藏過這個主題，請返回。',
	'favorite_add_succeed' => '指定主題已成功添加到收藏夾中，現在將回到上一頁。',
	'favorite_update_succeed' => '收藏夾已成功更新，現在將轉入更新後的收藏夾。',
	'favorite_is_full' => '您的收藏夾已滿，請在繼續操作前刪除一些不用的收藏。',
	'favorite_repeat' => '對不起，不能重複收藏主題或版塊，請返回。',
	'favorite_add_referer' => '指定板塊或主題已成功添加到收藏夾中，現在將轉入收藏前頁面。',

	'subscription_exists' => '您過去已經訂閱過這個主題，請返回。',
	'subscription_add_succeed' => '您選擇的主題已經成功訂閱，現在將回到上一頁。',
	'subscription_update_succeed' => '訂閱列表已經成功更新，現在將轉入更新後的訂閱列表。',
	'subscription_is_full' => '您的訂閱列表已滿，請在繼續操作前刪除一些不用的訂閱。',

	'search_ctrl' => '對不起，您在 $searchctrl 秒內只能進行一次搜索，請返回。',
	'search_toomany' => '對不起，管理員設置了每分鐘系統最多響應搜索請求 $maxspm 次，請返回並稍後再試。',
	'search_invalid' => '您沒有指定要搜索的關鍵字或用戶名，請返回重新填寫。',
	'search_forum_invalid' => '您沒有指定搜索論壇的範圍，請返回重新填寫。',
	'search_id_invalid' => '您指定的搜索不存在或已過期，請返回。',
	'search_redirect' => '搜索成功完成，現在將轉入結果頁面。',

	'member_nonexistence' => '指定的用戶不存在或已被刪除，請返回。',
	'member_list_disable' => '對不起，管理員禁止了會員列表功能。',
	'email_friend_invalid' => '相關項目沒有填寫完整，請返回修改。',
	'email_friend_succeed' => '您的推薦已經通過 Email 發給朋友，現在將轉入原帖。',
	'announcement_nonexistence' => '目前沒有公告供查看，請返回。',
	'mark_read_succeed' => '所有論壇已被標記已讀，現在將轉入論壇首頁。',
	'email_verify_invalid' => '您在 24 小時內只能提交一次驗證 Email 請求，請返回。',
	'email_verify_succeed' => '確認 Email 已經發送，請用郵件中提供的方法激活您的帳號。',
	'submit_verify_succeed' => '審核請求提交成功，現在將返回控制面板首頁。',
	'activate_succeed' => '您好，$member[username]，您的帳號已被成功激活，現在將轉入論壇首頁。',
	'activate_illegal' => '您所用的 ID 不存在或您不是等待驗證會員。',
	'poll_overdue' => '投票已經過期，請返回。',
	'poll_choose_most' => '此投票最多只能選擇 {$pollarray[maxchoices]} 項，請返回修改。',
	'poll_maxchoices_expiration_invalid' => '對不起，最多可選項數與有效記票天數只接受數字，請返回修改。',

	'trade_closed' => '本交易已關閉',
	'trade_invalid' => '無效的交易請求',
	'trade_credits_no_enough' => '您的 {$extcredits[$creditstrans][title]} 不足，無法用 {$extcredits[$creditstrans][title]} 換取商品的優惠，請返回修改。',
	'trade_by_myself' => '您無法購買自己的商品，請返回修改。',
	'trade_input_no' => '請輸入正確的商品數，請返回修改。',
	'trade_lack' => '商品剩餘數量不足，請返回修改。',
	'trade_alipay_please' => '對不起，支付寶賬戶不能為空，請返回修改。',
	'trade_please_name' => '對不起，商品名稱不能為空，請返回修改。',
	'trade_price_between' => '對不起，商品價格必須在 '.$mintradeprice.' 元至 '.$maxtradeprice.' 元之間，請返回修改。',
	'trade_price_more_than' => '對不起，商品價格必須大於 $mintradeprice 元，請返回修改。',
	'trade_please_locus' => '對不起，商品所在地不能為空，請返回修改。',
	'tread_please_number' => '對不起，商品數量不能為空，請返回修改。',

	'reward_cant_operate' => '對不起，您不能設置最佳答案, 請返回。',
	'reward_cant_self' => '對不起，您不能把自己的回復設置成最佳答案, 請返回。',
	'reward_repeat_selection' => '不能重複選定最佳答案, 請返回。',
	'reward_completion' => '您好，最佳答案設置成功，請返回。',
	'reward_credits_invalid' => '對不起，懸賞積分設置不合理，請返回修改。',
	'reward_credits_please' => '對不起，懸賞積分不能為空，請返回修改。',
	'reward_credits_fall' => '對不起，懸賞積分不能降低, 請返回修改。',
	'reward_credits_between' => '對不起，懸賞積分必須在 $minrewardprice 與 $maxrewardprice 之間, 請返回修改。',
	'reward_credits_shortage' => '對不起，積分餘額不足，請返回修改。',


	'activity_stop' => '對不起，活動已停止申請，請返回。',
	'activity_repeat_apply' => '對不起，活動不能重複申請。',
	'activity_completion' => '您好，活動申請成功，請等待發起人審核。',
	'activity_choice_applicant' => '您好，請選擇活動申請者才能進一步審核。',
	'activity_auditing_completion' => '您好，活動審核完畢。',
	'activity_fromtime_please' => '對不起，活動開始時間不能為空，請返回修改。',
	'activity_fromtime_error' => '對不起，活動開始時間格式不正確，請返回修改。',
	'activity_sort_please' => '對不起，活動所屬類別不能為空，請返回修改。',
	'activity_address_please' => '對不起，活動地點不能為空，請返回修改。',
	'activity_totime_error' => '對不起，活動徵集截止日期格式不正確，請返回修改。',
	'activity_smaller_current' => '對不起，活動開始時間不能小於當前時間',
	'post_poll_inputmore' => '對不起，投票選項不能只填寫一項，請返回修改。',


	'getpasswd_account_notmatch' => '用戶名，Email 地址或安全提問不匹配，請返回修改。',
	'getpasswd_account_invalid' => '對不起，管理員和超級版主不能使用取回密碼功能，請返回。',
	'getpasswd_illegal' => '您所用的 ID 不存在或已經過期，無法取回密碼。',
	'getpasswd_send_succeed' => '取回密碼的方法已經通過 Email 發送到您的信箱中，<br>請在 3 天之內到論壇修改您的密碼。',
	'getpasswd_succeed' => '您的密碼已重新設置，請使用新密碼登錄。',

	'blog_nonexistence' => '指定的用戶不存在，或其文集中沒有文章。',
	'blog_topic_nonexistence' => '指定的文章不存在或已被刪除，請返回。',
	'blog_category_isnull' => '當前作者在指定欄目內沒有文集，請返回。',
	'blog_add_illegal' => '對不起，您不是本主題的作者，不能加入或移除文集。',
	'blog_add_succeed' => '文章已成功加入或移除，現在將轉入主題頁。',

	'threadmod_nonexistence' => '主題管理記錄不存在，或管理記錄已經過期並刪除，請返回。',

	'pm_newbie_span' => '對不起，您只在註冊時間起 $newbiespan 小時後才有發短消息權限，請返回。',
	'pm_box_isfull' => '您的信箱已滿，在閱讀短消息前必須刪除一些不用的信息。',
	'pm_nonexistence' => '對不起，短消息不存在或已被刪除。',
	'pm_flood_ctrl' => '對不起，您兩次發消息間隔少於 $floodctrl 秒，請不要灌水！',
	'pm_send_nonexistence' => '收件人 $msgto 不存在，請返回修改。',
	'pm_send_invalid' => '您的消息沒有填寫完整，請返回修改。',
	'pm_send_toomany' => '收件人數量超過 $maxpmsend 人，請返回修改。',
	'pm_send_ignore' => '$member[username] 拒絕接受您或所有人發來的短消息，請返回修改。',
	'pm_send_succeed' => '短消息發送成功，現在將轉入消息列表。',
	'pm_delete_succeed' => '指定消息成功刪除，現在將轉入消息列表。',
	'pm_mark_unread_succeed' => '標記為未讀成功，現在將轉入消息列表。',
	'pm_ignore_succeed' => '忽略列表已成功更新，現在將轉入消息列表。',

	'plugin_nopermission' => '對不起，您沒有權限使用此插件模塊。',
	'plugin_module_nonexistence' => '指定的插件模塊文件($modfile)不存在或存在語法錯誤，請檢查是否已將插件完整上傳。',

	'admin_nopermission' => '對不起，您沒有權限使用管理功能。',
	'admin_expiration_invalid' => '您設置的有效期限超出系統允許的範圍，請返回修改。',
	'admin_reason_invalid' => '對不起，您在進行操作前需要選擇或輸入原因，請返回修改。',
	'admin_moderate_invalid' => '對不起，您沒有選擇主題，請返回修改。',
	'admin_getip_nopermission' => '對不起，您沒有權限查看比您高級的管理員 IP，請返回。',
	'admin_delpost_invalid' => '您沒有選擇要刪除的帖子，請返回。',
	'admin_move_illegal' => '您選擇的目標論壇與原論壇相同，請返回修改。',
	'admin_move_invalid' => '您沒有選擇目標論壇或分類，請返回修改。',
	'admin_split_invalid' => '這個主題沒有回復，無法分割，請返回。',
	'admin_split_subject_invalid' => '您沒有輸入標題，請返回修改。',
	'admin_split_new_invalid' => '您沒有選擇要分割入新主題的帖子，請返回修改。',
	'admin_merge_nonexistence' => '您指定的主題 ID (tid) 不存在，請返回修改。',
	'admin_merge_invalid' => '對不起，您沒有權限合併當前論壇以外的主題或將主題與自身合併，請返回。',
	'admin_succeed' => '管理操作成功，現在將轉入主題列表。',
	'admin_succeed_next' => '管理操作成功，現在將轉入後續操作。',
	'admin_copy_invalid' => '您沒有選擇目標論壇或分類，請返回修改。',
	'admin_copy_hava_mod' => '目標論壇需要內容審核，您無權將主題直接轉移到那裡。',
	'admin_copy_nopermission' => '對不起，你沒有權限移動到目標論壇，請返回。',

	'supe_post_reply_succeed' => '非常感謝，您的回復已經發佈，現在將轉入主題頁。',
	'supe_post_reply_succeed' => '非常感謝，您的回復已經發佈，現在將轉入主題頁。',
	'supe_resource_not_exist' => '該資源不存在，或者被刪除。請返回。',
	'supe_resource_is_not_of_you' => '該資源不是您所發佈，您沒有權力操作他人的資源。請返回。',
	'supe_resource_have_imported_into_forum' => '該資源已經導入論壇， 請不要重複導入。請返回。',
	'supe_imported_succeed' => '你所選擇的資源已經成功導入論壇！',
	'supe_pls_select_forum' => '您選擇論壇的論壇不存在或者您沒有權限導入！請返回修改。',
	'supe_newthread_import_mod_succeed' => '你所選擇的資源已經成功導入論壇！<br>管理員設置了需要對新主題進行審核，現在將轉入主題列表，您的帖子通過審核後將被顯示出來。',
	'supe_imported_newthread_have_replies' => '對不起，管理員設置了需要對該論壇的帖子進行審核，您的資源已經有人回復，不能導入該論壇，請您返回嘗試選擇其它論壇。',
	'supe_post_edit_succeed' => '您的帖子編輯成功，現在將轉入主題頁。',
	'supe_post_reply_succeed' => '非常感謝，您的回復已經發佈，現在將轉入主題頁。',
	'supe_post_newthread_succeed' => '非常感謝，您的主題已經發佈，現在將轉入主題頁。',
	'supe_pushsetting_nohand' => '當前論壇設置不允許手工推送到 SupeSite，請返回檢查。',
	'supe_pushsetting_noopen' => '論壇沒有開啟 SupeSite，您不能推送主題，請返回檢查。',
	'supe_imported_trade_notallowed' => '對不起！您無法將該商品導入論壇，導致此結果的原因可能是論壇沒有開啟交易功能，或者管理員沒有設置交易帳號，請返回。',
	'supe_imported_trade_forum_notallowed' => '對不起！您沒有權限將此商品導入該論壇，導致此結果的原因可能是您所選擇的論壇不允許發佈交易主題，或者您所在的用戶沒有權限進行交易，請返回。',

	'special_noaction' => '特殊主題不允許進行此操作，請返回。',
	'special_refundment_invalid' => '特殊主題不能執行強制退款！',
	'auditstatuson_succeed' => '審核成功，點擊查看該帖。',
	'audit_edit_succeed' => '<a href=\"javascript:if(opener)opener.location.reload();window.close();\">編輯成功， 點擊關閉本頁。</a>',

	'todays_birthdays_banned' => '對不起，管理員禁止了顯示生日會員功能。',
	'switch_status_now' => '正在切換您的狀態。'
);

?>